searchNodes=[{"type":"module","doc":"ExCell is used to split larger views in smaller cells that can be reused and easily packaged with Javascript and CSS. A cell consists of a couple of files: cells | - avatar | | - template . html . eex | | - view . html . eex | | - style . css ( optional ) | | - index . js ( optional ) | - header ... You can render the cell in a view, controller or another cell by adding the following code: cell(AvatarCell, class: &quot;CustomClassName&quot;, user: %User{}) This would generate the following HTML when you render the cell: &lt;span class=&quot;AvatarCell&quot; data-cell=&quot;AvatarCell&quot; data-cell-params=&quot;{}&quot;&gt; &lt;img src=&quot;/images/foo/avatar.jpg&quot; class=&quot;AvatarCell-Image&quot; alt=&quot;foo&quot; /&gt; &lt;/span&gt;","title":"ExCell","ref":"ExCell.html"},{"type":"function","doc":"","title":"ExCell.class_name/2","ref":"ExCell.html#class_name/2"},{"type":"function","doc":"","title":"ExCell.config/2","ref":"ExCell.html#config/2"},{"type":"function","doc":"","title":"ExCell.container/5","ref":"ExCell.html#container/5"},{"type":"function","doc":"","title":"ExCell.module_relative_to/2","ref":"ExCell.html#module_relative_to/2"},{"type":"function","doc":"","title":"ExCell.options/5","ref":"ExCell.html#options/5"},{"type":"function","doc":"","title":"ExCell.relative_name/2","ref":"ExCell.html#relative_name/2"},{"type":"behaviour","doc":"An ExCell Adapter defines the way the adapter outputs its HTML. The adapter requires a function called adapter that accepts a map container name, attributes, params and the content. It should return a Phoenix.HTML safe string.","title":"ExCell.Adapter","ref":"ExCell.Adapter.html"},{"type":"callback","doc":"","title":"ExCell.Adapter.container/1","ref":"ExCell.Adapter.html#c:container/1"},{"type":"type","doc":"","title":"ExCell.Adapter.html/0","ref":"ExCell.Adapter.html#t:html/0"},{"type":"type","doc":"","title":"ExCell.Adapter.options/0","ref":"ExCell.Adapter.html#t:options/0"},{"type":"module","doc":"The CellJS adapter can be used to output the cells as HTML compatible with cells-js . CellsJS was written with ExCell in mind. Tags are automatically closed when they are part of the void elements specification. CellsJS uses two predefined attributes to parse the Javascript. First it will look for the data-cell cell attribute and match it to the defined Cell in Javascript. Second it will take the JSON arguments set on the data-cell-params attribute and use that to initialize the cell with user defined parameters.","title":"ExCell.Adapters.CellJS","ref":"ExCell.Adapters.CellJS.html"},{"type":"function","doc":"The attributes function is used to auto fill the attributes for a container with the data attributes.","title":"ExCell.Adapters.CellJS.attributes/4","ref":"ExCell.Adapters.CellJS.html#attributes/4"},{"type":"function","doc":"The container renders HTML with the attributes, class name and data attributes prefilled. The HTML is rendered with Phoenix.HTML.Tag.","title":"ExCell.Adapters.CellJS.container/1","ref":"ExCell.Adapters.CellJS.html#container/1"},{"type":"function","doc":"","title":"ExCell.Adapters.CellJS.container/2","ref":"ExCell.Adapters.CellJS.html#container/2"},{"type":"function","doc":"The data_attribute function is used to build up the data attributes and set the default data-cell and data-cell-params attributes.","title":"ExCell.Adapters.CellJS.data_attribute/4","ref":"ExCell.Adapters.CellJS.html#data_attribute/4"},{"type":"function","doc":"","title":"ExCell.Adapters.CellJS.element/2","ref":"ExCell.Adapters.CellJS.html#element/2"},{"type":"function","doc":"","title":"ExCell.Adapters.CellJS.void_element?/1","ref":"ExCell.Adapters.CellJS.html#void_element?/1"},{"type":"function","doc":"","title":"ExCell.Adapters.CellJS.void_elements/0","ref":"ExCell.Adapters.CellJS.html#void_elements/0"},{"type":"behaviour","doc":"Cells are used to tightly couple your templates, views and Javascript. It is heavily inspired by React by Facebook and Rails Cells by Trailblazer.","title":"ExCell.Cell","ref":"ExCell.Cell.html"},{"type":"function","doc":"Returns the name of the module as a string. Module namespaces are replaced by a dash. Example iex(0)&gt; AvatarCell.name() &quot;AvatarCell&quot; iex(1)&gt; User.AvatarCell.name() &quot;User-AvatarCell&quot;","title":"ExCell.Cell.__adapter__/0","ref":"ExCell.Cell.html#__adapter__/0"},{"type":"macro","doc":"Cells require you to use the using macro to use them. This ensures that the cell namespaces are used. The cell allows you to override the class_name and params attributes. Options When you use the __using__ macro you can specify a namespace it uses as its base to add the class and cells-js tags :namespace - The base namespace it uses to base the name and class_name on Examples defmodule AppWeb.AvatarCell do use ExCell.Cell , namespace : AppWeb end iex(0)&gt; AvatarCell . name &quot;AvatarCell&quot; defmodule AppWeb.AvatarCell do use ExCell.Cell end iex(0)&gt; AvatarCell . name &quot;AppWeb-AvatarCell&quot;","title":"ExCell.Cell.__using__/1","ref":"ExCell.Cell.html#__using__/1"},{"type":"function","doc":"Generates the HTML attribute name based on the cell name. Can be overriden to pre- or postfix the attribute name. Examples iex(0)&gt; AvatarCell . cell_name ( ) &quot;AvatarCell&quot;","title":"ExCell.Cell.cell_name/0","ref":"ExCell.Cell.html#cell_name/0"},{"type":"function","doc":"Generates the CSS class name based on the cell name. Can be overriden to pre- or postfix the class name or to create a distinct class name with CSS modules. Examples iex(0)&gt; AvatarCell . class_name ( ) &quot;AvatarCell&quot;","title":"ExCell.Cell.class_name/0","ref":"ExCell.Cell.html#class_name/0"},{"type":"callback","doc":"","title":"ExCell.Cell.class_name/0","ref":"ExCell.Cell.html#c:class_name/0"},{"type":"function","doc":"Returns the container of a cell as a Phoenix.Tag. iex(0)&gt; Phoenix.HTML . safe_to_string ( AvatarCell . container ) &quot;&lt;div class= \\&quot; AvatarCell \\&quot; data-cell= \\&quot; AvatarCell \\&quot; data-cell-params= \\&quot; {} \\&quot; &gt;&quot;","title":"ExCell.Cell.container/0","ref":"ExCell.Cell.html#container/0"},{"type":"function","doc":"Returns the container of a cell as a Phoenix.Tag with attributes added to the data-cell-params attribute. This is used to add parameters to cell-js cells. Examples iex(0)&gt; Phoenix.HTML . safe_to_string ( AvatarCell . container ( %{ foo : &quot;bar&quot; } ) ) &quot;&lt;a class= \\&quot; AvatarCell \\&quot; data-cell= \\&quot; AvatarCell \\&quot; data-cell-params= \\&quot; {&amp;quot;foo&amp;quot;:&amp;quot;bar&amp;quot;}&quot; &gt; &quot;","title":"ExCell.Cell.container/1","ref":"ExCell.Cell.html#container/1"},{"type":"function","doc":"","title":"ExCell.Cell.container/2","ref":"ExCell.Cell.html#container/2"},{"type":"function","doc":"","title":"ExCell.Cell.container/3","ref":"ExCell.Cell.html#container/3"},{"type":"function","doc":"","title":"ExCell.Cell.name/0","ref":"ExCell.Cell.html#name/0"},{"type":"callback","doc":"","title":"ExCell.Cell.params/0","ref":"ExCell.Cell.html#c:params/0"},{"type":"function","doc":"Combines the parameters set on the cell with custom parameters for a specific instance Examples iex(0)&gt; AvatarCell . params %{ hello : &quot;world&quot; } iex(0)&gt; AvatarCell . params ( %{ foo : &quot;bar&quot; } ) %{ hello : &quot;world&quot; , foo : &quot;bar&quot; }","title":"ExCell.Cell.params/1","ref":"ExCell.Cell.html#params/1"},{"type":"module","doc":"Cell methods that render a cell directly to a controller","title":"ExCell.Controller","ref":"ExCell.Controller.html"},{"type":"function","doc":"Renders a cell directly from a controller without having to use a view. Examples defmodule AppWeb.UserController do use AppWeb , :controller import Cell.Controller def avatar ( conn , _params ) do conn |&gt; cell ( AvatarCell , user : conn . user ) end end","title":"ExCell.Controller.cell/1","ref":"ExCell.Controller.html#cell/1"},{"type":"function","doc":"","title":"ExCell.Controller.cell/2","ref":"ExCell.Controller.html#cell/2"},{"type":"function","doc":"","title":"ExCell.Controller.cell/3","ref":"ExCell.Controller.html#cell/3"},{"type":"module","doc":"Cell helpers used to render the cells in both Views and Cells","title":"ExCell.View","ref":"ExCell.View.html"},{"type":"function","doc":"Renders a cell in the view. Examples iex(0)&gt; safe_to_string ( AppWeb.AvatarView . cell ( AvatarCell ) ) &quot;&lt;div class=&quot; AvatarCell &quot; ...&gt;&quot; iex(1)&gt; safe_to_string ( AppWeb.AvatarView . cell ( AvatarCell , do : &quot;Foo&quot; ) ) &quot;&lt;div class=&quot; AvatarCell &quot; ...&gt;Foo&lt;/div&gt;&quot; iex(2)&gt; safe_to_string ( AppWeb.AvatarView . cell ( AvatarCell , user : % User { name : &quot;Bar&quot; } ) ) &quot;&lt;div class=&quot; AvatarCell &quot; ...&gt;Bar&lt;/div&gt;&quot; iex(3)&gt; safe_to_string ( AppWeb.AvatarView . cell ( AvatarCell , % Plug.Conn { } |&gt; assign ( :user , % User { name : &quot;Bar&quot; } ) ) ) &quot;&lt;div class=&quot; AvatarCell &quot; ...&gt;Bar&lt;/div&gt;&quot; iex(4)&gt; safe_to_string ( AppWeb.AvatarView . cell ( AvatarCell , &quot;Hello&quot; ) ) &quot;&lt;div class=&quot; AvatarCell &quot; ...&gt;Hello&lt;/div&gt;&quot;","title":"ExCell.View.cell/1","ref":"ExCell.View.html#cell/1"},{"type":"function","doc":"","title":"ExCell.View.cell/2","ref":"ExCell.View.html#cell/2"},{"type":"function","doc":"","title":"ExCell.View.cell/3","ref":"ExCell.View.html#cell/3"},{"type":"function","doc":"Renders the cell directly as a string, used for testing purposes. Examples iex(0)&gt; AppWeb.AvatarView . cell_to_string ( AvatarCell ) &quot;&lt;div class=&quot; AvatarCell &quot; ...&gt;&quot; iex(1)&gt; AppWeb.AvatarView . cell_to_string ( AvatarCell , do : &quot;Foo&quot; ) &quot;&lt;div class=&quot; AvatarCell &quot; ...&gt;Foo&lt;/div&gt;&quot; iex(2)&gt; AppWeb.AvatarView . cell_to_string ( AvatarCell , user : % User { name : &quot;Bar&quot; } ) &quot;&lt;div class=&quot; AvatarCell &quot; ...&gt;Bar&lt;/div&gt;&quot;","title":"ExCell.View.cell_to_string/1","ref":"ExCell.View.html#cell_to_string/1"},{"type":"function","doc":"","title":"ExCell.View.cell_to_string/2","ref":"ExCell.View.html#cell_to_string/2"},{"type":"function","doc":"","title":"ExCell.View.cell_to_string/3","ref":"ExCell.View.html#cell_to_string/3"},{"type":"function","doc":"Returns the relative path of a module to the namespace. This method is used to determine the template path of the cell. Examples iex(0)&gt; ExCell.View . relative_path ( AppWeb.AvatarCell , AppWeb ) &quot;avatar&quot; iex(1)&gt; ExCell.View . relative_path ( AppWeb.Namespace.AvatarCell , AppWeb ) &quot;namespace/avatar&quot;","title":"ExCell.View.relative_path/2","ref":"ExCell.View.html#relative_path/2"}]